<!DOCTYPE html>
<meta name="viewport" content="width=device-width, initial-scale=1">
<html id="fullscreen">

<head>
    <title>Modbus Debug</title>
    <script src='../js/jquery.min.js'></script>

    <link rel='stylesheet' type="text/css" href='../css/meti_merged.css'>

    <script src='../js/meti_merged.js'></script>
    <script src='../js/meti_utils.js'></script>

    <style>
        .modbus_data {
            margin-top: 5px;
        }

        #balance_length {
            font-size: x-small;
            margin-left: 10px;
        }

        .class_btn {
            cursor: pointer;
        }

        .sniffer_params {
            background: #007bff;
            color: white;
            border-radius: .2rem;
            font-size: smaller;
        }

        #sniffer_table {
            font-size: x-small;
        }

        .sniffer_key {
            text-align: right;
            padding: 0.2rem !important;
        }

        .sniffer_value {
            font-weight: 600;
            padding: 0.2rem !important;
        }

        #table_div {
            font-family: 'Courier New', Courier, monospace;
            font-size: x-small;
            width: 95%;
            height: 70vh;
            overflow: scroll;
            font-weight: bold;
        }

        #registration_status
        {
            color: red;
            font-size: medium;
            visibility:hidden;
        }
    </style>

</head>

<body>
    <div id="main_body">
        <div w3-include-html="meti_bst.html"></div>

        <div class="col-sm-10 p-1">
            <div class="border border-primary p-1">
                <div>
                    <button type="button" class="class_btn" id="button_startStop">Stop</button>
                    <button type="button" class="class_btn" id="button_clear">Clear</button>
                    <button type="button" class="class_btn" id="button_scroll">Scroll to End </button>
                    <label id="balance_length">500</label>
                    <label id="registration_status" class="m-1">(Unregistered)</label>
                </div>

                <div id="table_div">
                    <table id="sniffer_table" class="table table-sm table-primary table-hover">
                        <thead class="sniffer_params">
                            <tr>
                                <th scope="col" style="width:4%">Sl</th>
                                <th scope="col" style="width:8%">Date/Time</th>
                                <th scope="col" style="width:4%">Type</th>
                                <th scope="col" style="width:4%">Index</th>
                                <th scope="col">Modbus String</th>
                            </tr>
                        </thead>
                        <tbody id="sniffer_table_body">
                            <!-- Sniffer data table comes here... -->
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>

</body>

<script>
    w3IncludeHTML();

    $(document).ready(function () {
        // The following lines are for ServerEvents....
        // ServerEvent functions start here....
        var g_serverEventsOk = true;
        var g_serverEventsWaitForRestart = false;
        var timer1 = null;
        var g_log_enabled = true;
        var g_scrollToEnd = true;

        var MAX_LENGTH = 500;
        var IDX_SLNO = 0;
        var IDX_TIMESTAMP = 1;
        var IDX_TYPE = 2;
        var IDX_MODBUS_STRING = 3;
        var IDX_SNIFFER_INDEX = 4;

        // var input_ctr = MAX_LENGTH;

        $("#balance_length").html(MAX_LENGTH);

        setupEventSource();

        $("#button_clear").on("click", function () {
            $("#sniffer_table_body").html("");
        });

        $("#button_startStop").on("click", function () {
            if (g_log_enabled == true) {
                g_log_enabled = false;
                $("#button_startStop").html("Start");
            } else {
                g_log_enabled = true;
                $("#button_startStop").html("Stop");
            }
        });

        $("#button_scroll").on("click", function () {
            g_scrollToEnd = true;
            scrollToEnd();
        });

        $("#table_div").scroll(function () {
            if ($(this).scrollTop() + $(this).innerHeight() >= $(this)[0].scrollHeight) {
                g_scrollToEnd = true;
            } else {
                g_scrollToEnd = false;
            }
        });

        function setupEventSource() {
            if (typeof (EventSource) !== "undefined") {
                // Use the following line while using in device....

                if (LOCAL_HOST == true) {
                    var source = new EventSource("http://localhost/play/index.php/quickIoT/server_event_test");
                } else {
                    var source = new EventSource("/modbus_event");
                }

                var ev_error = source.onerror = function (ev) {
                    // console.log("Error...");
                    // console.log(ev);
                }

                var ev_message = source.onmessage = function (ev) {
                    g_serverEventsOk = true;
                    if (g_log_enabled == true) {
                        var response = ev.data;

                        dataParase(ev.data);

                        if (g_scrollToEnd == true) {
                            scrollToEnd();
                        }
                    }
                }

                if (timer1 != null) {
                    clearInterval(timer1);
                }
                timer1 = setInterval(function () {
                    if (g_serverEventsOk == false) {
                        if (g_serverEventsWaitForRestart == false) {
                            ev_error = null;
                            ev_message = null;

                            if (source != null) {
                                source.close();
                                source = null;
                            }

                            // Minimum 8 seconds + random 8 seconds
                            random = Math.floor(Math.random() * 8000);
                            waitTime = 8000 + random;
                            console.log("Connection closed!!! Restarting in " + waitTime + " ms.. ")

                            g_serverEventsOk = true;
                            g_serverEventsWaitForRestart = true;
                            setTimeout(function () {
                                setupEventSource();
                                g_serverEventsWaitForRestart = false;
                            }, waitTime)
                        }
                    } else {
                        g_serverEventsOk = false;
                    }
                }, 15000);
            } else {
                // document.getElementById("result").innerHTML = ";
                $("#table_div").html("Sorry, your browser does not support server-sent events...");
            }
        }

        function scrollToEnd() {
            $('html, #table_div').stop(true, false).animate({
                scrollTop: $('#table_div').prop("scrollHeight")
            }, 500);
        }
        // ServerEvent functions end here....

        function dataParase(newData) {
            //process first data
            var last_pos = newData.indexOf("#") + 1;
            rowData = newData.substr(0, last_pos).split("^");
            AddToDataTable(rowData);

            // //process second data
            // if (newData.length > last_pos) {
            //     rowData = newData.substr(last_pos, newData.indexOf("#", last_pos)).split(",");
            //     AddToDataTable(rowData);
            // }
            // newDataLine = newData;
        }

        function AddToDataTable(rowData) {
            var row_slno = $("#sniffer_table_body tr").length + 1;

            if (row_slno > MAX_LENGTH) {
                $("#sniffer_table_body").html("");
                row_slno = 1;
            }

            var tr = $("<tr></tr>")
                .addClass("w_table_row")
                .attr("id", "row_" + row_slno);

            //slno
            var th_slno = $("<td scope='row'></td>")
                .html(row_slno);

            //date_time
            var td1 = $("<td></td>")
                .html(rowData[IDX_TIMESTAMP]);

            //Type
            var td2 = $("<td></td>")
                .html(rowData[IDX_TYPE]);

            //sniffer index
            if (rowData[IDX_SNIFFER_INDEX] != "-1") {
                var td3 = $("<td></td>")
                    .html(rowData[IDX_SNIFFER_INDEX]);
            }
            else {
                var td3 = $("<td></td>")
                    .html(' ');
            }

            //modbus string with space
            // var new_modbus_str = '';
            // for (var index = 0; index < rowData[IDX_MODBUS_STRING].length; index = index + 2) {
            //     new_modbus_str += rowData[IDX_MODBUS_STRING].substr(index, 2) + " ";
            // }

            //Modbus String
            var td4 = $("<td></td>")
                .html(rowData[IDX_MODBUS_STRING]);

            tr.append(th_slno);
            tr.append(td1);
            tr.append(td2);
            tr.append(td3);
            tr.append(td4);
            $("#sniffer_table_body").append(tr);
        }

        function add_new_command(obj) {
            var new_cmd = obj.attr('data-cmd');
            var new_cmd_spaced = obj.attr('data-cmd_spaced');
            var cmd_found = false;

            //check if already exists
            $.each(g_sniffer_db.command, function (idx, val) {
                if (val.req == new_cmd) {
                    cmd_found = true;
                    return false;       //found, exit                    
                }
            });

            if (cmd_found == false) {
                var new_idx = -1;
                $.each(g_sniffer_db.command, function (idx, val) {
                    if (val.req == '') {
                        new_idx = idx;
                        return false;
                    }
                });

                if (new_idx >= 0) {
                    $("#sel_index").html('');
                    $.each(g_sniffer_db.command, function (idx, val) {
                        var opt = $('<option></option>')
                            .val(idx)
                            .addClass('dropdown-item')
                            .addClass('dd-item')
                            .text(idx + ' - ' + val.req);

                        $("#sel_index").append(opt);
                    });

                    if (new_idx < g_sniffer_db.command.length) {
                        $("#sel_index").val(new_idx);
                    } else {
                        $("#sel_index").val(0);
                    }

                    $("#sel_cmd")
                        .val(new_cmd_spaced)
                        .attr("data-cmd", new_cmd);
                }
            } else {
                alert("Aready exists...")
            }

            console.log(g_sniffer_db.command);
        }

        $("#button_save").on("click", function() {
            save_sniffer();
        });

        function save_sniffer() {
            var debug = 0;
            new_idx = $("#sel_index").val();
            new_cmd = $("#sel_cmd").attr("data-cmd");
            g_sniffer_db.command[new_idx].req = new_cmd;

            var url = "/saveSnifferConfig";
            if (LOCAL_HOST == true) {
                url = "http://localhost/play/index.php/quickIoT/save_sniffer_config";
            }

            var type = 'POST';
            var data = {
                sniffer_config: JSON.stringify(g_sniffer_db),
                sniffer_mode: 0
            };

            $.ajax({
                url: url,
                type: type,
                data: data,
                success: function (response) {
                    if (debug == 1) {
                        console.log(response);
                    }
                    else {
                        // console.log(js_response);
                        var result = response.result;

                        if (result == 1) {
                            alert(response.message);
                        }
                        else if (result == 0) {
                            alert(response.message);
                        }
                        table_refresh();
                    }
                },
                error: function (jqXHR, exception, response) {
                    alert('POST Error!');
                    console.log("test");
                    table_refresh();
                }
            });
        }

        function table_refresh() {

        }

        function displaySnifferParams() {
            if (g_sniffer_db.enabled == false) {
                $("#registration_status").css('visibility','visible');
                $("#button_save").attr("disabled","disabled");
            }
        }

        setTimeout(function () {
            readSnifferConfigFromFS(displaySnifferParams);
        }, 1000);
    });
</script>